package provaintermedia;

import java.io.Serializable;

public class Messaggio
    implements Serializable {
  public static int LOGIN = 0;
  public static int ARTICOLO = 1;
  public static int OFFERTA = 2;
  public static int RIFIUTO = 3;
  public static int RIALZO = 4;
  public static int FINEOK = 5;
  public static int DESERTA = 6;
  public static int AGGIUDICATO = 7;

  private static String[] codici = {
      "LOGIN", "ARTICOLO", "OFFERTA", "RIFIUTO",
      "RIALZO", "FINEOK", "DESERTA", "AGGIUDICATO"};

  private int codice;
  private Serializable messaggio;
  private float prezzo;

  public Messaggio(int codice, Serializable messaggio, float prezzo) {
    this.codice = codice;
    this.messaggio = messaggio;
    this.prezzo = prezzo;
  }

  public static Messaggio messaggioLogin(String nome) {
    return new Messaggio(LOGIN, nome, -1);
  }

  public static Messaggio messaggioArticolo(Articolo articolo, float prezzoBase) {
    return new Messaggio(ARTICOLO, articolo, prezzoBase);
  }

  public static Messaggio messaggioOfferta(Articolo articolo,
                                           float prezzoAttuale) {
    return new Messaggio(OFFERTA, articolo, prezzoAttuale);
  }

  public static Messaggio messaggioRifiuto() {
    return new Messaggio(RIFIUTO, null, -1);
  }

  public static Messaggio messaggioRialzo(float prezzo) {
    return new Messaggio(RIALZO, null, prezzo);
  }

  public static Messaggio messaggioFineOK(Articolo articolo, float prezzo) {
    return new Messaggio(FINEOK, articolo, prezzo);
  }

  public static Messaggio messaggioDeserta(Articolo articolo, float prezzo) {
    return new Messaggio(DESERTA, articolo, prezzo);
  }

  public static Messaggio messaggioAggiudicato(Articolo articolo, float prezzo) {
    return new Messaggio(AGGIUDICATO, articolo, prezzo);
  }

  public int getCodice() {
    return codice;
  }

  public Serializable getMessaggio() {
    return messaggio;
  }

  public float getPrezzo() {
    return prezzo;
  }

  public String toString() {
    return "Messaggio di " + codici[codice] + ": " + messaggio
        +
        ( ( (codice != LOGIN) && (codice != RIFIUTO)) ? (" - prezzo: " + prezzo) :
         "");
  }
}