package provaintermedia;
import java.io.*;
import java.net.*;
import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author Lorenzo Masetti
 * @version 1.0
 */

public class OutputClient implements Runnable {
  private ObjectOutputStream oos;
  private Vector messageQueue=new Vector();
  private boolean attivo = true;


    /**
     * Crea un <code>OutputClient</code>
     *
     * @param o l'output stream relativo al client
     * @exception IOException se non riesce a creare l'ObjectOutputStream
     */
    public OutputClient(ObjectOutputStream o) throws IOException {
      oos = o;
  }

    /**
     * Aggiunge un nuovo messaggio alla coda di quelli da inviare
     *
     * @param msg il <code>Messaggio</code> da aggiungere
     */
    public void add(Messaggio msg) {
    synchronized (messageQueue) {
      messageQueue.add(msg);
      messageQueue.notify();
    }
  }

    /**
     * Metodo implementato da Runnable. Mette il thread in attesa di
     * messaggi da spedire e ogni volta che arriva un nuovo messaggio lo
     * spedisce al cliente
     *
     */
    public void run() {
    while (attivo) {
      synchronized (messageQueue) {
        try {
          if (messageQueue.size() > 0) {
            Object o = messageQueue.remove(0);
            oos.writeObject(o);
          }
          else {
            messageQueue.wait();
          }
        } catch (IOException e) {
          e.printStackTrace();
        } catch (InterruptedException e) {
          e.printStackTrace();
        }
      }
    }
  }

    /**
     * Per fermare il thread creato a partire da questa classe
     *
     */
    public void stop() {
    attivo=false;
  }
}
